//+------------------------------------------------------------------+
//|                                             ZeroLag MACD DBL.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_level1  0.0
#property indicator_buffers 2
#property indicator_color1  Red
#property indicator_color2  DarkBlue
#property indicator_width1  1
#property indicator_width2  1
extern string ExtParam1 = "EURUSD";
extern string ExtParam2 = "GBPUSD";
extern int    FastEMA   = 12;
extern int    SlowEMA   = 24;
extern int    SignalEMA = 9;
//---- buffers
double ExtMapBuffer1[], ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
//--- indicator buffers mapping
    SetIndexStyle (0, DRAW_LINE);
    SetIndexBuffer (0, ExtMapBuffer1);
    SetIndexLabel (0, ExtParam1); 
    SetIndexStyle (1, DRAW_LINE);
    SetIndexBuffer (1, ExtMapBuffer2);
    SetIndexLabel (1, ExtParam2);
    IndicatorShortName ("ZeroLag MACD[" + ExtParam1 + "&" + ExtParam2 + "](" + (string) FastEMA + "," + (string) SlowEMA + "," + (string) SignalEMA + ")");
//---
    return (INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit (const int reason)
{
//----
    
//----
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate (
    const int rates_total,
    const int prev_calculated,
    const datetime &time[],
    const double &open[],
    const double &high[],
    const double &low[],
    const double &close[],
    const long &tick_volume[],
    const long &volume[],
    const int &spread[])
{
    int counted_bars = prev_calculated;
//---
    if (prev_calculated < 0) return (-1);
    int limit;
    if (prev_calculated > 0)
    {
        counted_bars--;
        limit = rates_total - counted_bars;
    }
    else limit = rates_total - 1;
    for (int bar = limit; bar >= 0; bar--)
    {
        ExtMapBuffer1[bar] = iCustom (ExtParam1, _Period, "ZeroLag MACD", FastEMA, SlowEMA, SignalEMA, 0, iBarShift (ExtParam1, _Period, Time[bar]));
        ExtMapBuffer2[bar] = iCustom (ExtParam2, _Period, "ZeroLag MACD", FastEMA, SlowEMA, SignalEMA, 0, iBarShift (ExtParam2, _Period, Time[bar]));
    }
//--- return value of prev_calculated for next call
    return (rates_total);
}
//+------------------------------------------------------------------+
